DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Vector Map - Custom Annotations

Annotations are containers for images, text blocks, and custom content. By using annotations, you can display additional information to your end users and improve the readability of data visualized within your app.

To create annotations, populate the JavaScript VectorMap's annotations array. Each object in the array configures an individual annotation. To specify settings for all annotations, use the commonAnnotationSettings object. Individual settings take precedence over common settings.

Backend API
$(() => { const formatNumber = new Intl.NumberFormat('en-US', { maximumFractionDigits: 0 }).format; $('#vector-map').dxVectorMap({ bounds: [-118, 55, -80, 23], commonAnnotationSettings: { type: 'custom', template(annotation, container) { const { data } = annotation; const contentItems = ["<svg class='annotation'>", "<image href='../../../../images/flags/", data.name.replace(/\s/, '').toLowerCase(), ".svg' width='60' height='40' />", "<rect class='border' x='0' y='0' />", "<text x='70' y='25' class='state'/>", "<text x='0' y='60'>", "<tspan class='caption'>Capital:</tspan>", "<tspan class='capital' dx='5'/>", "<tspan dy='14' x='0' class='caption'>Population:</tspan>", "<tspan class='population' dx='5'/>", "<tspan dy='14' x='0' class='caption'>Area:</tspan>", "<tspan class='area' dx='5'/>", "<tspan dx='5'>km</tspan><tspan dy='-2' class='sup'>2</tspan>", '</text></svg>']; const content = $(contentItems.join('')); content.find('.state').text(data.name); content.find('.capital').text(data.capital); content.find('.population').text(formatNumber(data.population)); content.find('.area').text(formatNumber(data.area)); content.appendTo(container); }, }, annotations: statesData, layers: [{ dataSource: DevExpress.viz.map.sources.usa, }], }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/world.js"></script> <script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/africa.js"></script> <script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/canada.js"></script> <script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/eurasia.js"></script> <script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/europe.js"></script> <script src="https://cdn3.devexpress.com/jslib/26.1.4/js/vectormap-data/usa.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="vector-map"></div> </div> </body> </html>
#vector-map { height: 440px; } .annotation { font-size: 12px; } .border { width: 60px; height: 40px; stroke: rgba(191, 191, 191, 0.25); stroke-width: 1px; fill: transparent; } .state { font-weight: 500; font-size: 14px; } .caption { font-weight: 500; } .sup { font-size: 0.8em; }
const statesData = [{ coordinates: [-75.4999, 43.00035], data: { name: 'New York', population: 19746227, capital: 'Albany', area: 141297, }, }, { coordinates: [-89, 40], offsetX: -100, offsetY: -80, data: { name: 'Illinois', population: 12880580, capital: 'Springfield', area: 149995, }, }, { coordinates: [-81.760254, 27.994402], data: { name: 'Florida', population: 19893297, capital: 'Tallahassee', area: 170312, }, }, { coordinates: [-100, 31], data: { name: 'Texas', population: 26956958, capital: 'Austin', area: 695662, }, }, { coordinates: [-119.417931, 36.778259], data: { name: 'California', population: 38802500, capital: 'Sacramento', area: 423967, }, }];

You can set each annotation type property to "text", "image", or "custom". In this demo, annotation type has been set to "custom".

Custom annotations require that you specify your own display template in SVG format. As you can see in the demo code, you can access annotation data within template markup.

For more information on annotation settings, refer to the annotations[] help topic.

Backend API
import React from 'react';
import VectorMap, {
Layer,
CommonAnnotationSettings,
Annotation,
} from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/usa.js';
import { statesData } from './data.ts';
import AnnotationTemplate from './AnnotationTemplate.tsx';
const bounds = [-118, 55, -80, 23];
const App = () => (
<VectorMap
id="vector-map"
bounds={bounds}>
<Layer
dataSource={mapsData.usa}
>
</Layer>
<CommonAnnotationSettings
type="custom"
render={AnnotationTemplate}
>
</CommonAnnotationSettings>
{statesData.map((state) => (
<Annotation
coordinates={state.coordinates}
offsetX={state.offsetX}
offsetY={state.offsetY}
key={state.data.name}
data={state.data}
>
</Annotation>
))
}
</VectorMap>
);
export default App;
import React from 'react';
import VectorMap, {
Layer,
CommonAnnotationSettings,
Annotation,
} from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/usa.js';
import { statesData } from './data.js';
import AnnotationTemplate from './AnnotationTemplate.js';
const bounds = [-118, 55, -80, 23];
const App = () => (
<VectorMap
id="vector-map"
bounds={bounds}
>
<Layer dataSource={mapsData.usa}></Layer>
<CommonAnnotationSettings
type="custom"
render={AnnotationTemplate}
></CommonAnnotationSettings>
{statesData.map((state) => (
<Annotation
coordinates={state.coordinates}
offsetX={state.offsetX}
offsetY={state.offsetY}
key={state.data.name}
data={state.data}
></Annotation>
))}
</VectorMap>
);
export default App;
import React from 'react';
import type { ICommonAnnotationSettingsProps } from 'devextreme-react/vector-map';
const getImagePath = (name: string) => `../../../../images/flags/${name?.replace(/\s/, '')}.svg`;
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
const AnnotationTemplate: ICommonAnnotationSettingsProps['render'] = ({
data: {
name, capital, population, area,
},
}) => (
<svg className="annotation">
<image href={getImagePath(name)} width="60" height="40" />
<rect x={0} y={0} className="border"></rect>
<text x="70" y="25" className="state">{name}</text>
<text x="0" y="60">
<tspan className="caption">Capital:</tspan>
<tspan className="capital" dx="5">{capital}</tspan>
<tspan dy="14" x="0" className="caption">Population:</tspan>
<tspan className="population" dx="5">{formatNumber(population)}</tspan>
<tspan dy="14" x="0" className="caption">Area:</tspan>
<tspan className="area" dx="5">{formatNumber(area)}</tspan>
<tspan dx="5">km</tspan>
<tspan className="sup" dy="-2">2</tspan>
</text>
</svg>
);
export default AnnotationTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const statesData = [{
coordinates: [-75.4999, 43.00035],
data: {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
},
}, {
coordinates: [-89, 40],
offsetX: -100,
offsetY: -80,
data: {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
},
}, {
coordinates: [-81.760254, 27.994402],
data: {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
},
}, {
coordinates: [-100, 31],
data: {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
},
}, {
coordinates: [-119.417931, 36.778259],
data: {
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
},
}];
declare module 'devextreme-dist/js/vectormap-data/usa.js' {
type Position = number[];
type Geometry =
| { type: 'Point'; coordinates: Position }
| { type: 'MultiPoint'; coordinates: Position[] }
| { type: 'LineString'; coordinates: Position[] }
| { type: 'MultiLineString'; coordinates: Position[][] }
| { type: 'Polygon'; coordinates: Position[][] }
| { type: 'MultiPolygon'; coordinates: Position[][][] };
interface Feature {
type: 'Feature';
geometry: Geometry;
properties: Record<string, unknown>;
}
interface FeatureCollection {
type: 'FeatureCollection';
features: Feature[];
// eslint-disable-next-line spellcheck/spell-checker
bbox?: number[];
}
const usa: FeatureCollection;
export { usa };
export default usa;
}
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
const getImagePath = (name) => `../../../../images/flags/${name?.replace(/\s/, '')}.svg`;
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
const AnnotationTemplate = ({
data: {
name, capital, population, area,
},
}) => (
<svg className="annotation">
<image
href={getImagePath(name)}
width="60"
height="40"
/>
<rect
x={0}
y={0}
className="border"
></rect>
<text
x="70"
y="25"
className="state"
>
{name}
</text>
<text
x="0"
y="60"
>
<tspan className="caption">Capital:</tspan>
<tspan
className="capital"
dx="5"
>
{capital}
</tspan>
<tspan
dy="14"
x="0"
className="caption"
>
Population:
</tspan>
<tspan
className="population"
dx="5"
>
{formatNumber(population)}
</tspan>
<tspan
dy="14"
x="0"
className="caption"
>
Area:
</tspan>
<tspan
className="area"
dx="5"
>
{formatNumber(area)}
</tspan>
<tspan dx="5">km</tspan>
<tspan
className="sup"
dy="-2"
>
2
</tspan>
</text>
</svg>
);
export default AnnotationTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const statesData = [
{
coordinates: [-75.4999, 43.00035],
data: {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
},
},
{
coordinates: [-89, 40],
offsetX: -100,
offsetY: -80,
data: {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
},
},
{
coordinates: [-81.760254, 27.994402],
data: {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
},
},
{
coordinates: [-100, 31],
data: {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
},
},
{
coordinates: [-119.417931, 36.778259],
data: {
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
},
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}
.annotation {
font-size: 12px;
}
.border {
width: 60px;
height: 40px;
stroke: rgba(191, 191, 191, 0.25);
stroke-width: 1px;
fill: transparent;
}
.state {
font-weight: 500;
font-size: 14px;
}
.caption {
font-weight: 500;
}
.sup {
font-size: 0.8em;
}
You can set each annotation type property to "text", "image", or "custom". In this demo, annotation type has been set to "custom".
Custom annotations require that you specify your own display template in SVG format. As you can see in the demo code, you can access annotation data within template markup.
For more information on annotation settings, refer to the annotations[] help topic.

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Vector Map - Custom Annotations

Annotations are containers for images, text blocks, and custom content. By using annotations, you can display additional information to your end users and improve the readability of data visualized within your app.

To create annotations, populate the VectorMap's annotations array. Each object in the array configures an individual annotation. To specify settings for all annotations, use the commonAnnotationSettings object. Individual settings take precedence over common settings.

Backend API
<template> <DxVectorMap id="vector-map" :bounds="bounds" > <DxLayer :data-source="usa" /> <DxCommonAnnotationSettings type="custom" template="annotationTemplate" /> <DxAnnotation v-for="state in statesData" :coordinates="state.coordinates" :offset-x="state.offsetX" :offset-y="state.offsetY" :data="state.data" :key="state.data.name" /> <template #annotationTemplate="{ data }"> <AnnotationTemplate :annotation="data"/> </template> </DxVectorMap> </template> <script setup lang="ts"> import { ref } from 'vue'; // @ts-ignore import * as mapsData from 'devextreme-dist/js/vectormap-data/usa.js'; import { DxVectorMap, DxLayer, DxAnnotation, DxCommonAnnotationSettings, } from 'devextreme-vue/vector-map'; import { statesData } from './data.ts'; import AnnotationTemplate from './AnnotationTemplate.vue'; const usa = ref(mapsData.usa); const bounds = ref([-118, 55, -80, 23]); </script> <style> #vector-map { height: 440px; } </style>
<template> <svg class="annotation"> <image :href="getImagePath()" width="60" height="40" /> <rect x="0" y="0" class="border" /> <text x="70" y="25" class="state" >{{ data.name }}</text> <text x="0" y="60" > <tspan class="caption">Capital:</tspan><tspan class="capital" dx="5" >{{ data.capital }}</tspan><tspan dy="14" x="0" class="caption" >Population:</tspan><tspan class="population" dx="5" >{{ formatNumber(data.population) }}</tspan><tspan dy="14" x="0" class="caption" >Area:</tspan><tspan class="area" dx="5" >{{ formatNumber(data.area) }}</tspan><tspan dx="5">km</tspan><tspan class="sup" dy="-2" >2</tspan> </text> </svg> </template> <script setup lang="ts"> import { ref } from 'vue'; type Annotation = Record<'data', Record<string, unknown>>; const props = withDefaults(defineProps<{ annotation?: Annotation }>(), { annotation: () => ({} as Annotation), }); const data = ref<Record<string, any>>(props.annotation.data); const getImagePath = () => `../../../../images/flags/${data.value.name.replace(/\s/, '')}.svg`; const formatNumber = new Intl.NumberFormat('en-US', { minimumFractionDigits: 0, }).format; </script> <style> .annotation { font-size: 12px; } .border { width: 60px; height: 40px; stroke: rgba(191, 191, 191, 0.25); stroke-width: 1px; fill: transparent; } .state { font-weight: 500; font-size: 14px; } .caption { font-weight: 500; } .sup { font-size: 0.8em; } </style>
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'typescript': { 'exports': 'ts', }, 'vue': { format: 'global', exports: 'Vue', esModule: true, }, 'vuex': { format: 'global', exports: 'Vuex', esModule: true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-dist/js/vectormap-data/*': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, 'anti-forgery': { loader: 'demo-ts-loader', }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', 'loaders:': '../../../../shared/loaders/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.40/dist/vue.global.js', '@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js', 'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'loaders:demo-ts-loader.js', 'demo-ts-shared': 'loaders:demo-ts-shared.js', 'vue-loader': 'loaders:demo-vue-loader.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
export const statesData = [{ coordinates: [-75.4999, 43.00035], data: { name: 'New York', population: 19746227, capital: 'Albany', area: 141297, }, }, { coordinates: [-89, 40], offsetX: -100, offsetY: -80, data: { name: 'Illinois', population: 12880580, capital: 'Springfield', area: 149995, }, }, { coordinates: [-81.760254, 27.994402], data: { name: 'Florida', population: 19893297, capital: 'Tallahassee', area: 170312, }, }, { coordinates: [-100, 31], data: { name: 'Texas', population: 26956958, capital: 'Austin', area: 695662, }, }, { coordinates: [-119.417931, 36.778259], data: { name: 'California', population: 38802500, capital: 'Sacramento', area: 423967, }, }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>

You can set each annotation type property to "text", "image", or "custom". In this demo, annotation type has been set to "custom".

Custom annotations require that you specify your own display template in SVG format. As you can see in the demo code, you can access annotation data within template markup.

For more information on annotation settings, refer to the annotations[] help topic.

Backend API
<dx-vector-map id="vector-map" [bounds]="[-118, 55, -80, 23]">
<dxi-vector-map-layer [dataSource]="usaMap"></dxi-vector-map-layer>
<dxo-vector-map-common-annotation-settings type="custom" template="template">
</dxo-vector-map-common-annotation-settings>
@for(data of states; track data.data) {
<dxi-vector-map-annotation
[data]="data.data"
[offsetX]="data.offsetX"
[offsetY]="data.offsetY"
[coordinates]="data.coordinates"
>
</dxi-vector-map-annotation>
}
<svg *dxTemplate="let annotation of 'template'" class="annotation">
<image attr.href="{{ getImagePath(annotation) }}" width="60" height="40" />
<rect x="0" y="0" class="border" />
<text x="70" y="25" class="state">{{ annotation.data.name }}</text>
<text x="0" y="60">
<tspan class="caption">Capital:</tspan>
<tspan class="capital" dx="5">{{ annotation.data.capital }}</tspan>
<tspan dy="14" x="0" class="caption">Population:</tspan>
<!-- display: inline -->
<tspan class="population" dx="5">{{
annotation.data.population | number : "3.0-0"
}}</tspan>
<tspan dy="14" x="0" class="caption">Area:</tspan>
<!-- display: inline -->
<tspan class="area" dx="5">{{
annotation.data.area | number : "3.0-0"
}}</tspan>
<tspan dx="5">km</tspan>
<tspan class="sup" dy="-2">2</tspan>
</text>
</svg>
</dx-vector-map>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DecimalPipe } from '@angular/common';
import { DxVectorMapModule } from 'devextreme-angular';
import * as mapsData from 'devextreme-dist/js/vectormap-data/usa.js';
import { StatesCollection, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxVectorMapModule,
DecimalPipe,
],
})
export class AppComponent {
usaMap = mapsData.usa;
states: StatesCollection[];
constructor(service: Service) {
this.states = service.getStatesData();
}
getImagePath = (annotation: StatesCollection) => {
const name = annotation.data.name.replace(/\s/, '');
return `../../../../images/flags/${name}.svg`;
};
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #vector-map {
height: 440px;
}
::ng-deep .annotation {
font-size: 12px;
}
::ng-deep .border {
width: 60px;
height: 40px;
stroke: rgba(191, 191, 191, 0.25);
stroke-width: 1px;
fill: transparent;
}
::ng-deep .state {
font-weight: 500;
font-size: 14px;
}
.caption {
font-weight: 500;
}
::ng-deep .sup {
font-size: 0.8em;
}
import { Injectable } from '@angular/core';
export class StatesCollection {
coordinates: number[];
offsetX?: number;
offsetY?: number;
data: { name: string, [key: string]: unknown };
}
const statesData: StatesCollection[] = [
{
coordinates: [-75.4999, 43.00035],
data: {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
},
},
{
coordinates: [-89, 40],
offsetX: -100,
offsetY: -80,
data: {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
},
},
{
coordinates: [-81.760254, 27.994402],
data: {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
},
},
{
coordinates: [-100, 31],
data: {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
},
},
{
coordinates: [-119.417931, 36.778259],
data: {
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
},
},
];
@Injectable()
export class Service {
getStatesData(): StatesCollection[] {
return statesData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
You can set each annotation type property to "text", "image", or "custom". In this demo, annotation type has been set to "custom".
Custom annotations require that you specify your own display template in SVG format. As you can see in the demo code, you can access annotation data within template markup.
For more information on annotation settings, refer to the annotations[] help topic.